﻿using BepInEx;
using UnboundLib;
using UnboundLib.Cards;
using OneCrazyMod.Cards;
using HarmonyLib;
using CardChoiceSpawnUniqueCardPatch.CustomCategories;

namespace OneCrazyMod
{
    // These are the mods required for our mod to work
    [BepInDependency("com.willis.rounds.unbound", BepInDependency.DependencyFlags.HardDependency)]
    [BepInDependency("pykess.rounds.plugins.moddingutils", BepInDependency.DependencyFlags.HardDependency)]
    [BepInDependency("pykess.rounds.plugins.cardchoicespawnuniquecardpatch", BepInDependency.DependencyFlags.HardDependency)]
    // Declares our mod to Bepin
    [BepInPlugin(ModId, ModName, Version)]
    // The game our mod is associated with
    [BepInProcess("Rounds.exe")]
    public class OneCrazyMod : BaseUnityPlugin
    {
        private const string ModId = "com.larree.rounds.AdamSandler";
        private const string ModName = "Adam Sandler's One Crazy Mod";
        public const string Version = "0.0.2"; // What version are we on (major.minor.patch)?
        public const string ModInitials = "ASOCM";

        public static OneCrazyMod instance { get; private set; }

        void Awake()
        {
            // Use this to call any harmony patch files your mod may have
            var harmony = new Harmony(ModId);
            harmony.PatchAll();
        }
        void Start()
        {
            instance = this;
            CustomCard.BuildCard<EscapeSequence>(); // Repeat for each card to be built
            CustomCard.BuildCard<Rats>();
            CustomCard.BuildCard<Balance>();
            CustomCard.BuildCard<BidenBeam>();
            CustomCard.BuildCard<BidenBlast>();
        }
    }
}